<?php

class Shopware_Plugins_Frontend_rvdwFilterLeft_Bootstrap extends Shopware_Components_Plugin_Bootstrap{


    public function getCapabilities(){
        return array(
            "install" => true,
            "update" => true,
            "enable" => true

        );
    }
    public function getLabel(){
            return "Filter Left";
        }

    public function getVersion(){
            return "1.0.0";
        }
    public function getInfo(){
            return array(
                "version" => $this->getVersion(),
                "label" => $this->getLabel(),
                "supplier" => "7synth",
                "description" => "This Plugin will display the Filter Options on the left in the listing view. The Sorting Options will stay on top as default.",
                "support" => "info@7synth.com",
                "link" => "http://7synth.com",
                "author" => "R.v.d.Waydbrink",
                "copyright" => "2015 R.v.d.Waydbrink",
                "license" => "by request"
            );
        }
    public function install(){
            $this->registerEvents();
            $this->createConfiguration();
            return array(
                "success" => true,
                "invalidateCache" => array("frontend")
            );
        }
    public function uninstall(){
            return array(
                "success" => true,
                "invalidateCache" => array("frontend")
            );
        }
    private function registerEvents(){
            $this->subscribeEvent(
                "Enlight_Controller_Action_PostDispatch_Frontend",
                "onPostDispatchFrontend"
            );

        }
    public function onPostDispatchFrontend(Enlight_Event_EventArgs $arguments)
        {

            /**@var $controller Shopware_Controllers_Frontend_Index*/
            $controller = $arguments->getSubject();

            /**
             * @var $request Zend_Controller_Request_Http
             */
            $request = $controller->Request();

            /**
             * @var $response Zend_Controller_Response_Http
             */
            $response = $controller->Response();

            /**
             * @var $view Enlight_View_Default
             */
            $view = $controller->View();

            //Check if there is a template and if an exception has occured
            if(!$request->isDispatched()||$response->isException()||!$view->hasTemplate() || $request->getModuleName() != "frontend") {
                return;
            }

            //Variablen im Frontend hinzufügen
            $config = Shopware()->Plugins()->Frontend()->rvdwFilterLeft()->Config();
            $view->rvdwFilterLeft  = $config;

            //Add our plugin template directory to load our snowflake extension.
            $view->addTemplateDir($this->Path() . 'Views/');

            $view->extendsTemplate('responsive/frontend/plugins/rvdwFilterLeft/index.tpl');
            $view->extendsTemplate('responsive/frontend/plugins/rvdwFilterLeft/listing_actions.tpl');
            $view->extendsTemplate('responsive/frontend/plugins/rvdwFilterLeft/listing_actions_left.tpl');

        }
    /**
     *
     * @param Enlight_Event_EventArgs $args
     * @return \Doctrine\Common\Collections\ArrayCollection
     */
    public function addLessFiles(Enlight_Event_EventArgs $args)
    {
        $less = new \Shopware\Components\Theme\LessDefinition(
        /* Configuration */
            array(
                'delivery' => $this->Config()->get('delivery'),
                'price' => $this->Config()->get('price'),
                'manufacturer' => $this->Config()->get('manufacturer'),
                'rating' => $this->Config()->get('rating')
            ),
            /* Less files to compile */
            array(__DIR__ . '/Views/responsive/frontend/_public/src/less/all.less'),
            /* Import directory */
            __DIR__
        );

        return new Doctrine\Common\Collections\ArrayCollection(array($less));
    }
    public function createConfiguration(){
        $form = $this->Form();
        $form->setElement("checkbox","collapse",
            array("label"=>"Collapse filters to button",
                "value"=>false,
                "description" => "Will only show the button for filter, not the filters.",
                "scope" => Shopware\Models\Config\Element::SCOPE_SHOP
            )
        );
        $form->setElement('select', 'appearance',
            array('label' => 'Appearance Order',
                "value" => array("above", 'Show filter above left category listing'),
                'store' => array(
                    array("above", 'Show filter above left category listing'),
                    array("underneath", ' Show filter underneath left category listing')
                ),
                "description" => "Choose were the filter will be displayed. Above or underneath the left category listing stack",
                'scope' => Shopware\Models\Config\Element::SCOPE_SHOP
            )
        );
        $form->setElement("checkbox","delivery",
            array("label"=>"Immmediate Delivery",
                "value"=>false,
                "description" => "Will show or hide filter.",
                  "scope" => Shopware\Models\Config\Element::SCOPE_SHOP
             )
        );
        $form->setElement("checkbox","price",
            array("label"=>"Price",
                "value"=>false,
                "description" => "Will show or hide filter.",
                  "scope" => Shopware\Models\Config\Element::SCOPE_SHOP
             )
        );
        $form->setElement("checkbox","manufacturer",
            array("label"=>"Manufacturer",
                "value"=>false,
                "description" => "Will show or hide filter.",
                  "scope" => Shopware\Models\Config\Element::SCOPE_SHOP
             )
        );
        $form->setElement("checkbox","rating",
            array("label"=>"Rating",
                "value"=>false,
                "description" => "Will show or hide filter.",
                "scope" => Shopware\Models\Config\Element::SCOPE_SHOP
            )
        );
        $form->save();
    }

}